#define NAM TRLO
#define name trlo

#define LOGF(name) printf

#include <stdlib.h>
#include "trlo.h"

#include "hwmap_mapvme.h"
void trcom_hwmap_error_internal(int, const char *, int, const char *, ...);
typedef void (*hwmap_error_internal_func)(int, const char *, int, const char
		*, ...);
hwmap_error_internal_func _hwmap_error_internal = trcom_hwmap_error_internal;

void 
trlo_init(struct TRLOIIModule *trloii)
{
	trlo_opaque volatile *trlo;

	trlo = trloii->trlo;

	trlo_setup_check_version(trlo);
	trlo_setup_readout_control(trlo, &trloii->ctrl, 0xcf, 0xc7, 1, 2);

	TRLO_WRITE(trlo, setup.max_multi_trig, 1);

	TRLO_WRITE(trlo, pulse.pulse, 
			TRLO_PULSE_MULTI_TRIG_BUF_CLEAR);
	TRLO_WRITE(trlo, pulse.pulse, 
			TRLO_PULSE_SERIAL_TSTAMP_BUF_CLEAR);
	TRLO_WRITE(trlo, pulse.pulse, 
			TRLO_PULSE_SERIAL_TSTAMP_FAIL_CLEAR);
	SERIALIZE_IO;
}

void
trlo_readout(struct TRLOIIModule *trloii, uint32_t **buffer)
{
	uint32_t rc = 0;
	uint32_t tpat_status = 0;
	uint32_t size = 0x1000;

	/* TODO: Insert header here */

	rc = trlo_read_multi_event_dt_held(trloii->trlo, &tpat_status);
	if (rc != 0) {
		printm("TRLO multi_event_dt_held readout problem, status=0x%08x.\n",
				tpat_status);
		abort();
	}

	rc = trlo_read_multi_event_no_dt(trloii->trlo, &trloii->ctrl, &tpat_status,
			buffer, (*buffer) + size, NULL, 1);
	if (rc != 0) {
		printm("TRLO multi_event_no_dt readout problem, status=0x%08x.\n",
				tpat_status);
		abort();
	}

	TRLO_WRITE(trloii->trlo, pulse.pulse,
			TRLO_PULSE_TRIG_SCALER_LATCH |
			TRLO_PULSE_MUX_SRC_SCALER_LATCH);

	SERIALIZE_IO;

	trlo_read_trig_scalers(trloii->trlo, &trloii->ctrl,
			buffer, (*buffer) + size, 0);	
}
